"use strict";
cc._RF.push(module, '5314fW1PGZEt4x2BDDWpRdC', 'Test');
// Test.ts

Object.defineProperty(exports, "__esModule", { value: true });
var property = cc._decorator.property;
var ccclass = cc._decorator.ccclass;
var Test = /** @class */ (function (_super) {
    __extends(Test, _super);
    function Test() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.m_iSpeed = 5;
        _this.m_iCreateInterval = 100;
        _this.m_iMaxBiuCnt = 200;
        return _this;
    }
    Test.prototype.onLoad = function () {
        this.m_ndBiu = cc.find("Canvas/biubiubiu");
        this.m_ndBiu.active = false;
        this.m_arrBiuPool = new Array();
        this.m_arrBiuRunning = new Array();
        this.m_stSize = cc.view.getDesignResolutionSize();
        this.m_iTotDistance = 0;
    };
    Test.prototype.start = function () {
    };
    Test.prototype.update = function (dt) {
        if (this.m_arrBiuRunning.length <= 0 || this.m_iTotDistance % this.m_iCreateInterval == 0 && this.m_arrBiuRunning.length <= this.m_iMaxBiuCnt) {
            this.CreateBiu();
        }
        for (var i = 0; i < this.m_arrBiuRunning.length; ++i) {
            this.m_arrBiuRunning[i].y += this.m_iSpeed;
            // 销毁出镜的。
            if (this.m_arrBiuRunning[i].y >= this.m_stSize.height / 2) {
                this.m_arrBiuRunning[i].active = false;
                this.m_arrBiuPool.push(this.m_arrBiuRunning.splice(i, 1)[0]);
                --i;
                // 销毁一个新增一个。
                this.CreateBiu();
            }
        }
        this.m_iTotDistance += this.m_iSpeed;
    };
    Test.prototype.CreateBiu = function () {
        var ndBiu;
        if (this.m_arrBiuPool.length <= 0)
            ndBiu = cc.instantiate(this.m_ndBiu);
        else
            ndBiu = this.m_arrBiuPool.pop();
        ndBiu.active = true;
        ndBiu.x = (Math.random() >= 0.5 ? -1 : 1) * Math.random() * 265;
        ndBiu.y = -this.m_stSize.height / 2;
        if (ndBiu.parent != cc.Canvas.instance.node) {
            ndBiu.removeFromParent();
            cc.Canvas.instance.node.addChild(ndBiu);
        }
        this.m_arrBiuRunning.push(ndBiu);
    };
    __decorate([
        property(Number)
    ], Test.prototype, "m_iSpeed", void 0);
    __decorate([
        property(Number)
    ], Test.prototype, "m_iCreateInterval", void 0);
    __decorate([
        property(Number)
    ], Test.prototype, "m_iMaxBiuCnt", void 0);
    Test = __decorate([
        ccclass
    ], Test);
    return Test;
}(cc.Component));
exports.default = Test;

cc._RF.pop();